Loading...
Searching...
No Matches
awhitening.h File Reference

Spectral adaptive whitening. More...

Go to the source code of this file.

## Typedefs

typedef struct _aubio_spectral_whitening_t | aubio_spectral_whitening_t
| spectral whitening structure

## Functions

void | aubio_spectral_whitening_do (aubio_spectral_whitening_t *o, cvec_t *fftgrain)
| execute spectral adaptive whitening, in-place
aubio_spectral_whitening_t * | new_aubio_spectral_whitening (uint_t buf_size, uint_t hop_size, uint_t samplerate)
| creation of a spectral whitening object
void | aubio_spectral_whitening_reset (aubio_spectral_whitening_t *o)
| reset spectral whitening object
uint_t | aubio_spectral_whitening_set_relax_time (aubio_spectral_whitening_t *o, smpl_t relax_time)
| set relaxation time for spectral whitening
smpl_t | aubio_spectral_whitening_get_relax_time (aubio_spectral_whitening_t *o)
| get relaxation time of spectral whitening
uint_t | aubio_spectral_whitening_set_floor (aubio_spectral_whitening_t *o, smpl_t floor)
| set floor for spectral whitening
smpl_t | aubio_spectral_whitening_get_floor (aubio_spectral_whitening_t *o)
| get floor of spectral whitening
void | del_aubio_spectral_whitening (aubio_spectral_whitening_t *o)
| deletion of a spectral whitening

## Detailed Description

Spectral adaptive whitening.

References:

D. Stowell and M. D. Plumbley. Adaptive whitening for improved real-time audio onset detection. In Proceedings of the International Computer Music Conference (ICMC), 2007, Copenhagen, Denmark.

http://www.eecs.qmul.ac.uk/~markp/2007/StowellPlumbley07-icmc.pdf

S. Böck,, F. Krebs, and M. Schedl. Evaluating the Online Capabilities of Onset Detection Methods. In Proceedings of the 13th International Society for Music Information Retrieval Conference (ISMIR), 2012, Porto, Portugal.

http://ismir2012.ismir.net/event/papers/049_ISMIR_2012.pdf http://www.cp.jku.at/research/papers/Boeck_etal_ISMIR_2012.pdf

Definition in file awhitening.h.

## Typedef Documentation

## aubio_spectral_whitening_t

typedef struct _aubio_spectral_whitening_t aubio_spectral_whitening_t

spectral whitening structure

Definition at line 51 of file awhitening.h.

## Function Documentation

## aubio_spectral_whitening_do()

void aubio_spectral_whitening_do | ( | aubio_spectral_whitening_t * | o,
|  | cvec_t * | fftgrain )

execute spectral adaptive whitening, in-place

Parameters

  o | spectral whitening object as returned by new_aubio_spectral_whitening()
  fftgrain | input signal spectrum as computed by aubio_pvoc_do() or aubio_fft_do()

## aubio_spectral_whitening_get_floor()

smpl_t aubio_spectral_whitening_get_floor | ( | aubio_spectral_whitening_t * | o | ) |

get floor of spectral whitening

Parameters

  o | spectral whitening object as returned by new_aubio_spectral_whitening()

Returns
  floor value

## aubio_spectral_whitening_get_relax_time()

smpl_t aubio_spectral_whitening_get_relax_time | ( | aubio_spectral_whitening_t * | o | ) |

get relaxation time of spectral whitening

Parameters

  o | spectral whitening object as returned by new_aubio_spectral_whitening()

Returns
  relaxation time in seconds

## aubio_spectral_whitening_reset()

void aubio_spectral_whitening_reset | ( | aubio_spectral_whitening_t * | o | ) |

reset spectral whitening object

Parameters

  o | spectral whitening object as returned by new_aubio_spectral_whitening()

## aubio_spectral_whitening_set_floor()

uint_t aubio_spectral_whitening_set_floor | ( | aubio_spectral_whitening_t * | o,
|  | smpl_t | floor )

set floor for spectral whitening

Parameters

  o | spectral whitening object as returned by new_aubio_spectral_whitening()
  floor | value (typically between 1.e-6 and .2, defaults to 1.e-4)

## aubio_spectral_whitening_set_relax_time()

uint_t aubio_spectral_whitening_set_relax_time | ( | aubio_spectral_whitening_t * | o,
|  | smpl_t | relax_time )

set relaxation time for spectral whitening

Parameters

  o | spectral whitening object as returned by new_aubio_spectral_whitening()
  relax_time | relaxation time in seconds between 20 and 500, defaults 250

## del_aubio_spectral_whitening()

void del_aubio_spectral_whitening | ( | aubio_spectral_whitening_t * | o | ) |

deletion of a spectral whitening

Parameters

  o | spectral whitening object as returned by new_aubio_spectral_whitening()

## new_aubio_spectral_whitening()

aubio_spectral_whitening_t * new_aubio_spectral_whitening | ( | uint_t | buf_size,
|  | uint_t | hop_size,
|  | uint_t | samplerate )

creation of a spectral whitening object

Parameters

  buf_size | window size of input grains
  hop_size | number of samples between two consecutive input grains
  samplerate | sampling rate of the input signal